'use strict';
module.exports = function (config, data) {
  let outObject = {
    columns: [],
    data: []
  }

  let objectArray = {
    dinamico: [],
    dinamicoData: [],
    firstColum: [],
    firstColumData: [],
    dinamicField: [],
    previousLevel: false
  }

  // Revisa la cantidad de filas que deberia tener
  let lengthArr = function (config) {
    let totFilHead = 0
    let totFilData = 0

    for (let i = 0; i < config.length; i++) {
      if (config[i].HEAD === true && config[i].EJE_X !== null && config[i].EJE_Y !== null) {
        totFilHead = totFilHead < Math.abs(config[i].EJE_Y) ? Math.abs(config[i].EJE_Y) : totFilHead
      } else if (config[i].HEAD === false && config[i].EJE_X !== null && config[i].EJE_Y !== null) {
        totFilData = totFilData < Math.abs(config[i].EJE_Y) ? Math.abs(config[i].EJE_Y) : totFilData
      }
    }

    setArr(outObject.columns, totFilHead + 1, true)
    setArr(outObject.data, totFilData + 1, false)
    setArr(objectArray.dinamico, totFilHead + 1, true)
    setArr(objectArray.dinamicoData, totFilData + 1, true)
    setArr(objectArray.firstColum, totFilHead + 1, true)
    setArr(objectArray.firstColumData, totFilData + 1, true)
  }

  // Coloca la cantidad necesaria de arreglos y objetos
  let setArr = function (donde, cuantos, setType) {
    for (let i = 0; i < cuantos; i++) {
      if (setType === true) {
        donde.push([])
      } else if (setType === false) {
        donde.push({})
      }
    }
  }

  // Transpone la informacion y coloca la configuracion necesaria
  let setColumns = function () {
    for (let i = 0; i < config.length; i++) {
      let objectNow = config[i]

      if (objectNow.EJE_Y === null && objectNow.EJE_X === null && objectNow.HEAD === true) {
        // Separa las clases de thead
        outObject.theadClasses = objectNow.TEXTO
      } else if (objectNow.HEAD === true && objectNow.EJE_X !== null && objectNow.EJE_Y !== null && objectNow.TIPO_CELDA === 0) {
        // Agrega las columnas thead
        outObject.columns[Math.abs(objectNow.EJE_Y)].splice(objectNow.EJE_X, 0, setOptions(objectNow))
      } else if (objectNow.HEAD === true && objectNow.EJE_X !== null && objectNow.EJE_Y !== null && objectNow.TIPO_CELDA === 1) {
        // Solo es para el primer elemento de data. Carga los objetos por fila, indicando el dato que buscara de data.
        objectArray.firstColum[Math.abs(objectNow.EJE_Y)].splice(objectNow.EJE_X, 0, setOptions(objectNow))
        objectArray.previousLevel = true
      } else if (objectNow.HEAD === true && objectNow.EJE_X !== null && objectNow.EJE_Y !== null && objectNow.TIPO_CELDA === 2) {
        // Separa las columnas dinamicas que se van agregar conforme a los elementos de data.
        objectArray.dinamico[Math.abs(objectNow.EJE_Y)].splice(objectNow.EJE_X, 0, setOptions(objectNow))
      } else if (objectNow.HEAD === false && objectNow.EJE_X !== null && objectNow.EJE_Y !== null) {
        // Agrega las columnas tbody
        let key = outObject.data[Math.abs(objectNow.EJE_Y)]

        if (objectNow.TIPO_CELDA === 0) {
          setOptionsData(key, objectNow, objectArray.dinamicoData)
        } else if (objectNow.TIPO_CELDA === 1) {
          setOptionsData(key, objectNow, objectArray.firstColumData)
        }
      }
    }

    // Coloca un objeto vacio para que funcione correctamente con groupBy y groupByPersonal
    outObject.columns[outObject.columns.length - 1].unshift({ title: '' })
  }

  // Cambia los espacios en blanco por undefined
  let changeVal = function (str) {
    let splitStr = str.split(',')
    let arr = []
    for (let i = 0; i < splitStr.length; i++) {
      let cursor = splitStr[i]
      arr.push(cursor === '' ? undefined : cursor)
    }

    return arr
  }

  // Coloca las optiones al objeto a insertar
  let setOptions = function (object) {
    let setObject = {}
    if (object.TEXTO !== null) {
      setObject.title = object.TEXTO
    }

    if (object.COLSPAN !== null) {
      if (object.EJE_X === '0') {
        setObject.colspan = parseInt(object.COLSPAN) + 1
      } else {
        setObject.colspan = parseInt(object.COLSPAN)
      }
    }

    if (object.ROWSPAN !== null) {
      setObject.rowspan = object.ROWSPAN
    }

    if (object.FIELD !== null) {
      setObject.field = object.FIELD
    }

    if (object.COLUMN_RELATIONSHIP !== null) {
      setObject.column_relationship = object.COLUMN_RELATIONSHIP
    }

    return setObject
  }

  // Coloca las optiones al objeto que se convertira en fila en data
  let setOptionsData = function (key, objectNow, saveValue) {
    if (objectNow.FIELD !== null || objectNow.TEXTO !== null) {
      key[objectNow.FIELD] = objectNow.TEXTO
    }

    if (objectNow.COD_PRODUCTO !== null && !key.COD_PRODUCTO) {
      key.COD_PRODUCTO = objectNow.COD_PRODUCTO
    }

    if (objectNow.EJE_X !== null && objectNow.COD_PRODUCTO !== null && objectNow.NIVEL !== null && !key.NIVEL) {
      key.NIVEL = objectNow.NIVEL
    }

    if (objectNow.COLUMN_RELATIONSHIP !== null) {
      saveValue[Math.abs(objectNow.EJE_Y)] = changeVal(objectNow.COLUMN_RELATIONSHIP)
    }
  }

  // Convierte las filas de data a columnas de head
  let addDataHead = function () {
    for (let k = 0; k < data.length; k++) {
      let arrDinamico = null

      if (objectArray.previousLevel && k === 0) {
        arrDinamico = objectArray.firstColum
      } else {
        arrDinamico = objectArray.dinamico
      }

      for (let i = 0; i < arrDinamico.length; i++) {
        let ejeX = arrDinamico[i]

        for (let j = 0; j < ejeX.length; j++) {
          let objectNow = Object.assign({}, ejeX[j])
          if (objectNow.column_relationship) {
            objectNow.title = data[k][objectNow.column_relationship]
            outObject.columns[i].push(objectNow)
          } else {
            objectNow.field = objectNow.field + '_' + k
            outObject.columns[i].push(objectNow)
            objectArray.dinamicField.push(objectNow.field)
          }
        }
      }
    }
  }

  // Convierte las filas de data a columnas de data
  let addData = function () {
    for (let i = 0; i < data.length; i++) {
      let arrDinamico = null

      if (objectArray.previousLevel && i === 0) {
        arrDinamico = objectArray.firstColumData
      } else {
        arrDinamico = objectArray.dinamicoData
      }

      for (let j = 0; j < arrDinamico.length; j++) {
        let ejeX = arrDinamico[j]
        let countDinData = arrDinamico[j].length
        if (countDinData >= 1) {
          let inicioPart = i > 0 ? i * countDinData : i
          let finPart = i > 0 ? inicioPart + countDinData : 1 * countDinData
          let partArray = objectArray.dinamicField.slice(inicioPart, finPart)

          for (let l = 0; l < countDinData; l++) {
            let dataOut = outObject.data

            if (ejeX[l] === undefined) {
              dataOut[j][partArray[l]] = '-'
            } else {
              dataOut[j][partArray[l]] = data[i][ejeX[l]]
            }
          }
        }
      }
    }
  }

  // Init
  lengthArr(config)
  setColumns()
  addDataHead()
  addData()

  return outObject
}
